<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
  <div>
    <el-dialog
      :title="title"
      :close-on-click-modal="false"
      v-dialogDrag
      :append-to-body="true"
      width="1200px"
      height="500px"
      @close="close"
      @keyup.enter.native=""
      :visible.sync="visible">
    <el-form size="middle" :model="inputForm" ref="inputForm" v-loading="loading" :class="method==='view'?'readonly':''"  :disabled="status === 'audit' || status === 'taskFormDetail'|| method==='view'"
             label-width="150px">

      <el-divider v-if="(status === 'audit' || status === 'taskFormDetail'|| method==='view') && commonJS.isNotEmpty(inputForm.customerId)" content-position="left">
        <el-link  type="primary" :underline="false" icon="el-icon-document" @click="viewClient(inputForm.customerId)"><b>查看客户详情</b></el-link>
      </el-divider>
      <el-divider v-else content-position="left"><i class="el-icon-document"></i> 客户信息</el-divider>
      <el-row  :gutter="0">
        <el-col :span="12">
          <el-form-item label="委托方" prop="clientContacts"
                        :rules="[
                          // {required: true, message: '委托方', trigger: 'blur'}
                 ]">
            <el-input maxlength="100" @focus="openWorkClient2()" v-model="inputForm.clientContacts" placeholder="请选择委托方">
              <el-button slot="append" icon="el-icon-search" @click="openWorkClient2()"></el-button>
            </el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="客户编号" prop="customerNo"
                        :rules="[
                   ]">
            <el-input :disabled="true" v-model="inputForm.customerNo" placeholder="请填写客户编号" clearable></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="统一社会信用代码" prop="uscCode"
                        :rules="[
                   ]">
            <el-input :disabled="true" v-model="inputForm.uscCode" placeholder="请填写统一社会信用代码" clearable></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="委托方电话" prop="clientContactsPhone"
                        :rules="[
                          // {required: true, message: '委托方电话', trigger: 'blur'}
                 ]">
            <el-input maxlength="15" :disabled="true" v-model="inputForm.clientContactsPhone" placeholder="请输入委托方电话"
            ></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="地址" prop="address"
                        :rules="[
                   ]">
            <el-input :disabled="true" v-model="inputForm.address" placeholder="地址" clearable></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-divider content-position="left"><i class="el-icon-document"></i> 基本信息</el-divider>
      <el-row  :gutter="0">
        <el-col :span="12">
          <el-form-item label="合同名称" prop="contractName"
                        :rules="[{required: true, message: '合同名称不能为空', trigger: 'blur'}
                 ]">
            <el-input v-model="inputForm.contractName" placeholder="请输入合同名称"     clearable></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="合同编号" prop="contractNo">
            <el-input maxlength="64" :disabled="true" v-model="inputForm.contractNo" placeholder="自动生成"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="合同类型" prop="contractType"
                        :rules="[{required: true, message: '合同类型不能为空', trigger: 'blur'}
                 ]" >
            <el-select v-model="inputForm.contractType" :disabled="contractNoFlag" placeholder="请选择合同类型" style="width:100%;">
              <el-option
                v-for="item in $dictUtils.getDictList('cw_contract_type')"
                :key="item.value"
                :label="item.label"
                :value="item.value">
              </el-option>
            </el-select>
          </el-form-item>
        </el-col>
        <!--        <el-col :span="12">-->
        <!--          <el-form-item label="合同状态" prop="contractStatus">-->
        <!--            <el-input maxlength="64" v-model="inputForm.contractStatus" :disabled="true" placeholder="请输入合同状态"></el-input>-->
        <!--          </el-form-item>-->
        <!--        </el-col>-->
        <el-col :span="12">
          <el-form-item label="付款主体" prop="payerSubject"
                        :rules="[{required: true, message: '付款主体不能为空', trigger: 'blur'}
                 ]">
            <el-select v-model="inputForm.payerSubject" placeholder="请选择付款主体" style="width:100%;">
              <el-option
                v-for="item in $dictUtils.getDictList('cw_payment_subject')"
                :key="item.value"
                :label="item.label"
                :value="item.value">
              </el-option>
            </el-select>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="付款方式" prop="paymentMethod"
                        :rules="[
                 ]">
            <el-select v-model="inputForm.paymentMethod" placeholder="请选择付款方式" style="width:100%;">
              <el-option
                v-for="item in $dictUtils.getDictList('cw_payment_method')"
                :key="item.value"
                :label="item.label"
                :value="item.value">
              </el-option>
            </el-select>
          </el-form-item>
        </el-col>
        <el-col>
          <el-form-item label="付款描述" prop="paymentDescribe"
                        :rules="[
               ]">
            <el-input type="textarea" v-model="inputForm.paymentDescribe" placeholder="请输入付款描述"
            ></el-input>
          </el-form-item>
        </el-col>

        <el-col :span="12">
          <el-form-item label="签约日期" prop="signingDate"
                        :rules="[
                {required: true, message:'请输入签约日期', trigger:'blur'}
               ]">
            <el-date-picker
              placement="bottom-start"
              value-format="yyyy-MM-dd"
              v-model="inputForm.signingDate"
              style="width: 100%"
              placeholder="选择日期">
            </el-date-picker>
          </el-form-item>
        </el-col>

        <el-col :span="12">
          <el-form-item label="合同份数" prop="contractNum"
                        :rules="[{required: true, message: '合同份数', trigger: 'blur'}
                 ]">
            <el-input maxlength="64" v-model="inputForm.contractNum" placeholder="请输入合同份数"></el-input>
          </el-form-item>
        </el-col>

        <el-col :span="12">
          <el-form-item label="对方合同编号" prop="contractOpposite">
            <el-input maxlength="64" v-model="inputForm.contractOpposite" placeholder="请填写对方合同编号"></el-input>
          </el-form-item>
        </el-col>

        <!--        <el-col :span="12">-->
        <!--          <el-form-item label="修改次数" prop="changeNum"-->
        <!--                        :rules="[{required: true, message: '修改次数', trigger: 'blur'}-->
        <!--                 ]">-->
        <!--            <el-input maxlength="64" :disabled="true" v-model="inputForm.changeNum" placeholder="请输入修改次数"></el-input>-->
        <!--          </el-form-item>-->
        <!--        </el-col>-->

        <el-col :span="12">
          <el-form-item  prop="department" label="所属部门">
            <SelectTree
              ref="officeTree"
              :props="{
                  value: 'id',             // ID字段名
                  label: 'name',         // 显示名称
                  children: 'children'    // 子级字段名
                }"

              :url="`/sys/office/treeData?type=1`"
              :value="inputForm.department"
              :accordion="true"
              size="medium"
              @getValue="(value) => {inputForm.department=value}"/>
          </el-form-item>
        </el-col>

        <el-col :span="12">
          <el-form-item label="创建人" prop="createBy"
                        :rules="[{required: true, message: '创建人', trigger: 'blur'}
                 ]">
            <el-input maxlength="64" :disabled="true" v-model="inputForm.createBy" placeholder="请输入创建人"></el-input>
          </el-form-item>
        </el-col>

        <el-col :span="12">
          <el-form-item label="创建时间" prop="createDate">
            <el-date-picker
              placement="bottom-start"
              value-format="yyyy-MM-dd"
              v-model="inputForm.createDate"
              style="width: 100%"
              :disabled="true"
              placeholder="选择日期">
            </el-date-picker>
          </el-form-item>
        </el-col>

        <el-col>
          <el-form-item label="合同金额类别" prop="contractAmountType"
                        :rules="[
                  {required: true, message:'请选择合同金额类别', trigger:'blur'}
               ]">
            <el-radio-group v-model="inputForm.contractAmountType">
              <el-radio v-for="item in $dictUtils.getDictList('contract_amount_type')" :label="item.value" >{{item.label}}</el-radio>
            </el-radio-group>
          </el-form-item>
        </el-col>

        <el-col :span="12">
          <el-form-item label="合同金额(元)" prop="contractAmount" v-if="inputForm.contractAmountType === '1'"
                        :rules="[
                  {required: true, message:'请输入合同金额(元)', trigger:'blur'}
               ]">
            <el-input maxlength="15" v-model="inputForm.contractAmount" placeholder="请输入合同金额(元)"
                      @keyup.native="inputForm.contractAmount = twoDecimalPlaces(inputForm.contractAmount)"
            ></el-input>
          </el-form-item>
        </el-col>

        <el-col :span="12">
          <el-form-item label="预计金额(元)" prop="predictAmount" v-if="inputForm.contractAmountType === '2'"
                        :rules="[
                  /*{required: true, message:'请输入预计金额(元)', trigger:'blur'}*/
               ]">
            <el-input maxlength="15" v-model="inputForm.predictAmount" placeholder="请输入预计金额(元)"
                      @keyup.native="inputForm.predictAmount = twoDecimalPlaces(inputForm.predictAmount)"
            ></el-input>
          </el-form-item>
        </el-col>

        <el-col :span="12">
          <el-form-item label="合同实际金额" prop="actualContractAmount">
            <el-input maxlength="64" :disabled="true" v-model="inputForm.actualContractAmount"
                      @keyup.native="inputForm.actualContractAmount = twoDecimalPlaces(inputForm.actualContractAmount)"
            ></el-input>
          </el-form-item>
        </el-col>

        <el-col :span="24">
          <el-form-item label="收费标准" prop="contractFees">
            <el-checkbox-group v-model="inputForm.contractFees">
              <el-checkbox @change="changeContractFee" v-for="item in $dictUtils.getDictList('contract_fee')" :label="item.value">
                {{item.label}}
              </el-checkbox>
            </el-checkbox-group>
          </el-form-item>
        </el-col>

        <el-col :span="24">
          <el-form-item prop="contractFee">
            <el-input style="width: 100%" placeholder="请选择收费标准" v-model="inputForm.contractFee"></el-input>
          </el-form-item>
        </el-col>

        <el-col :span="24">
          <el-form-item label="付款约定" prop="paymentAgreement">
            <el-input maxlength="1000" type="textarea" v-model="inputForm.paymentAgreement" placeholder="请输入付款约定"></el-input>
          </el-form-item>
        </el-col>

      </el-row>

      <el-tabs v-model="activeName" type="border-card" @tab-click="tabHandleClick">
        <el-tab-pane label="合同文件" name="contractProper">
          <span slot="label"><span style="color: red;border-top: 20px">*</span> 合同文件</span>
          <!--        合同文件-->
          <UpLoadComponent ref="uploadComponent"></UpLoadComponent>
        </el-tab-pane>
        <el-tab-pane label="参与签约方" name="contactParty">
          <span slot="label"><span style="color: red;border-top: 20px">*</span> 参与签约方</span>
          <el-row :gutter="15">
            <el-button type="primary" style="margin-bottom: 15px" size="mini" :disabled="status === 'audit' || status === 'taskFormDetail'|| method==='view'" @click="openWorkClient">
              新增参与签约方
            </el-button>
          </el-row>
          <el-row :gutter="15">
            <el-form>
              <vxe-table
                border
                show-overflow
                show-footer
                :column-config="{resizable: true}"
                ref="contactTable"
                :key="tableKeyClient"
                class="vxe-table-element"
                :data="inputForm.cwWorkClientContactDTOList"
                style=""
                @cell-click=""
                @edit-closed=""
                highlight-current-row
                :edit-config="{trigger: 'click', mode: 'row', showStatus: false, autoClear: false}"
              >
                <vxe-table-column align="center" field="no" title="客户编号" :edit-render="{}">
                  <template v-slot:edit="scope">
                    <el-input :readonly="true" v-model="scope.row.no" placeholder="客户编号" clearable></el-input>
                  </template>
                </vxe-table-column>
                <vxe-table-column align="center" field="name" title="客户名称" :edit-render="{}">
                  <template v-slot:edit="scope">
                    <el-input :readonly="true" v-model="scope.row.name" placeholder="客户名称" clearable></el-input>
                  </template>
                </vxe-table-column>
                <vxe-table-column align="center" title="操作" width="100">
                  <template v-slot="scope">
                    <el-button size="mini" :disabled="status === 'audit' || status === 'taskFormDetail'|| method==='view'" type="danger" @click="removeEvent(scope.row,scope.$rowIndex,'client')">删除</el-button>
                  </template>
                </vxe-table-column>
              </vxe-table>
            </el-form>
          </el-row>
        </el-tab-pane>
        <!--        <el-tab-pane  label="合同归档文件" name="archiveFile">-->
        <!--          &lt;!&ndash;        合同归档文件&ndash;&gt;-->
        <!--          <UpLoadComponent ref="archiveFile"></UpLoadComponent>-->
        <!--        </el-tab-pane>-->

      </el-tabs>

    </el-form>
    <el-image-viewer
      v-if="showViewer"
      :on-close="closeViewer"
      :url-list="[url]"
      zIndex="9999"/>
    <WorkClientChooseForm ref="workClientChooseForm" @getWorkClientChoose="getWorkClientChoose"></WorkClientChooseForm>
    <WorkClientChooseRadio ref="workClientChooseRadio" @getWorkClientRadioChoose="getWorkClientChoose2"></WorkClientChooseRadio>
    <WorkClientForm ref="workClientForm" @refreshList=""></WorkClientForm>
      <span slot="footer" class="dialog-footer">
      <el-button size="small" @click="close()" icon="el-icon-circle-close">关闭</el-button>
      <el-button size="small" v-if="method !== 'view'" type="primary" icon="el-icon-circle-check" @click="doSubmit()">确定</el-button>
    </span>
    </el-dialog>
  </div>
</template>

<script>
  // import WorkContractService from '@/api/sys/WorkContractService'
  import ContractInfoService from '@/api/cw/workContract/ContractInfoService'
  import UpLoadComponent from '@/views/common/UpLoadComponent'
  import SelectTree from '@/components/treeSelect/treeSelect.vue'
  import WorkClientSelect from '@/components/workClientInfoSelect'
  import WorkClientForm from '../../workClientInfo/WorkClientForm'
  import WorkClientChooseForm from '../../workClientInfo/WorkClientChooseForm'
  import WorkClientChooseRadio from '../../workClientInfo/WorkClientChooseRadio'
  import OSSSerive, {
    httpRequest,
    toHref,
    openWindowOnUrl,
    handleRemove,
    fileName
  } from '@/api/sys/OSSService'
  import moment from 'moment'
  import ElImageViewer from 'element-ui/packages/image/src/image-viewer'
  export default {
    data () {
      return {
        visable: false,
        gridData: [],
        radio: 0,
        tableData: [],
        dataList: [],
        dataListNew: [],
        title: '',
        method: '',
        isSubmit: false,
        visible: false,
        loading: false,
        contractNoFlag: false,
        returnForm: {
          customerId: '',  // 客户id
          address: '',
          uscCode: '',
          clientId: '',
          name: '',
          contractDate: '',
          effectiveDate: '',
          closingDate: '',
          contractType: '',
          contractAmountType: '',
          contractAmount: '',
          predictAmount: '',
          contractOpposite: '',
          contractFees: [],
          fees: '',
          contractFee: '',
          describes: '',
          contractSpecial: '',
          remarks: '',
          clientName: '',
          contractProperList: [],
          status: '',
          customerNo: '',
          customerName: ''
        },
        inputForm: {
          customerId: '',  // 客户id
          address: '',
          uscCode: '',
          customerNo: '',
          contractFees: [],
          contractFee: '',
          contractNo: '',
          contractType: '',
          contractName: '',
          payerSubject: '',
          paymentMethod: '',
          paymentDescribe: '',
          signingDate: '',
          contractAmount: '',
          predictAmount: '',
          actualContractAmount: '',
          contractNum: '2',
          contractStatus: '新创建',
          paymentAgreement: '',
          changeNum: '0',
          department: '',
          clientContacts: '',
          clientContactsPhone: '',
          createBy: JSON.parse(localStorage.getItem('user')).name,
          createId: JSON.parse(localStorage.getItem('user')).id,
          createDate: '',
          contractProperList: [],
          cwWorkClientContactDTOList: [],
          contractAmountType: '',
          contractOpposite: '',
          fees: ''
        },
        activeName: 'contractProper',
        filesArra2: [],
        fileList: [],
        isFlag: true,
        showViewer: false, // 显示查看器
        url: '',
        rowurl: '',
        src: '',
        onedit: false,
        type: '',
        loadProgress: 0, // 动态显示进度条
        progressFlag: false, // 关闭进度条
        promi: null,
        tableKeyClient: '1',
        keyWatch: ''
      }
    },
    props: {
      businessId: {
        type: String,
        default: ''
      },
      formReadOnly: {
        type: Boolean,
        default: false
      },
      status: {
        type: String,
        default: ''
      }
    },
    components: {
      ElImageViewer,
      UpLoadComponent,
      SelectTree,
      WorkClientSelect,
      WorkClientForm,
      WorkClientChooseForm,
      WorkClientChooseRadio
    },
    // computed: {
    //   officeName () {
    //     return JSON.parse(localStorage.getItem('user')).officeDTO.name
    //   }
    // },
    ossService: null,
    contractInfoService: null,
    created () {
      this.ossService = new OSSSerive()
      this.contractInfoService = new ContractInfoService()
    },
    mounted () {
      window.onPreview = this.onPreview
    },
    computed: {
      officeName () {
        return JSON.parse(localStorage.getItem('user')).officeDTO.name
      },
      bus: {
        get () {
          // this.$refs.archiveFile.setDividerName('附件', false)
          this.$refs.uploadComponent.setDividerName('附件', false)
          return this.businessId
        },
        set (val) {
          this.businessId = val
        }
      }
    },
    watch: {
      'keyWatch': {
        handler (newVal) {
          if (this.commonJS.isNotEmpty(this.bus)) {
            this.init('', this.bus)
          } else {
            this.$nextTick(() => {
              this.$refs.inputForm.resetFields()
            })
          }
        }
      }
    },
    methods: {
      getKeyWatch (keyWatch) {
        this.keyWatch = keyWatch
      },
      uploadVideoProcess (event, file, fileList) {
        this.progressFlag = true // 显示进度条
        this.loadProgress = parseInt(event.percent) // 动态获取文件上传进度
        if (this.loadProgress >= 100) {
          this.loadProgress = 100
          setTimeout(() => { this.progressFlag = false }, 1000) // 一秒后关闭进度条
        }
      },
      async toHref (row) {
        toHref(row)
      },
      onPreview (url) {
        this.url = url
        this.showViewer = true
      },
      // 关闭查看器
      closeViewer () {
        this.url = ''
        this.showViewer = false
      },
      init (method, id) {
        this.dataList = []
        this.dataListNew = []
        this.method = method
        // console.log('method', method)
        this.inputForm = {
          customerId: '',  // 客户id
          address: '',
          uscCode: '',
          customerNo: '',
          contractFees: [],
          contractFee: '',
          contractNo: '',
          contractType: '',
          contractName: '',
          payerSubject: '',
          paymentMethod: '',
          paymentDescribe: '',
          signingDate: '',
          fees: '',
          contractAmount: '',
          predictAmount: '',
          actualContractAmount: '',
          contractNum: '',
          contractStatus: '',
          paymentAgreement: '',
          changeNum: '',
          department: '',
          clientContacts: '',
          clientContactsPhone: '',
          createBy: JSON.parse(localStorage.getItem('user')).name,
          createId: JSON.parse(localStorage.getItem('user')).id,
          createDate: '',
          contractProperList: [],
          cwWorkClientContactDTOList: [],
          contractAmountType: '',
          contractOpposite: ''
        }
        this.inputForm.id = id
        if (method === 'add') {
          this.inputForm.id = 'add'
          this.title = `新建合同`
        } else if (method === 'edit') {
          this.title = '修改合同'
        } else if (method === 'view') {
          this.inputForm.showVi = false
          this.title = '查看合同详情'
        }
        this.visible = true
        this.loading = false
        this.$nextTick(() => {
          this.$refs.inputForm.resetFields()
          this.loading = true
          this.$refs.uploadComponent.clearUpload()
          // this.$refs.archiveFile.clearUpload()
          this.contractInfoService.findById(this.inputForm.id).then(({data}) => {
            this.inputForm = this.recover(this.inputForm, data)
            if (this.inputForm.contractNo) {
              this.contractNoFlag = true
            } else {
              this.contractNoFlag = false
            }
            if (this.commonJS.isEmpty(this.inputForm.contractAmountType)) {
              this.inputForm.contractAmountType = '1'
            }
            if (this.commonJS.isEmpty(this.inputForm.department)) {
              this.inputForm.department = JSON.parse(localStorage.getItem('user')).officeDTO.id
            }
            // 对数值进行判断是否为空,为空则赋值默认值
            // console.log('this.inputForm.contractStatus', this.inputForm.contractStatus)
            if (this.inputForm.contractStatus === undefined || this.inputForm.contractStatus === '') {
              this.inputForm.contractStatus = '新创建'
            }
            if (this.inputForm.contractNum === undefined || this.inputForm.contractNum === '') {
              this.inputForm.contractNum = '2'
            }
            if (this.inputForm.changeNum === undefined || this.inputForm.changeNum === '') {
              this.inputForm.changeNum = '0'
            }
            if (this.inputForm.createBy === undefined || this.inputForm.createBy === '') {
              this.inputForm.createBy = JSON.parse(localStorage.getItem('user')).name
            }
            if (this.inputForm.createId === undefined || this.inputForm.createId === '') {
              this.inputForm.createId = JSON.parse(localStorage.getItem('user')).id
            }
            if (this.commonJS.isEmpty(this.inputForm.createDate)) {
              this.inputForm.createDate = this.moment(new Date()).format('YYYY-MM-DD HH:mm:ss')
            }
            const f = []
            if (data.fees !== null && data.fees !== undefined && data.fees !== '') {
              data.fees.split(',').forEach(item => {
                if (item !== null && item !== undefined && item !== '') {
                  f.push(item)
                }
              })
            }
            this.inputForm.contractFees = f
            if (this.status === 'audit' || this.status === 'taskFormDetail') {
              method = 'view'
            }
            this.$refs.uploadComponent.newUpload(method, this.inputForm.contractProperList, 'cwWorkContract', null, null, null, null, false)
            // this.$refs.archiveFile.newUpload('view', [], 'cwWorkContract', null, null, null, null, false)
            this.loading = false
          })
        })
      },
      // 查看
      view (id) {
        this.$refs.workClientForm.init('view', id)
      },
      // 新增
      // eslint-disable-next-line no-dupe-keys
      async insertEvent (type) {
        if (type === 'client') {
          let d = {
            no: '',
            name: ''
          }
          if (this.commonJS.isEmpty(this.inputForm.cwWorkClientContactDTOList)) {
            this.inputForm.cwWorkClientContactDTOList = []
          }
          this.$refs.contactTable.insertAt(d)
          this.inputForm.cwWorkClientContactDTOList.push(d)
          this.tableKeyClient = Math.random()
        }
        // if (type === 'client') {
        //   await this.$refs.contactTable.insert().then((data) => {
        //     console.log('data', data)
        //     if (this.commonJS.isEmpty(this.inputForm.cwWorkClientContactDTOList)) {
        //       this.inputForm.cwWorkClientContactDTOList = []
        //     }
        //     this.$nextTick(() => {
        //       this.inputForm.cwWorkClientContactDTOList.push(data)
        //     })
        //   })
        // }
      },

      // 删除
      removeEvent (row, rowIndex, type) {
        if (type === 'client') {
          this.$refs.contactTable.remove(row)
          this.inputForm.cwWorkClientContactDTOList.splice(rowIndex, 1)
        }
      },
      openWorkClient () {
        this.$refs.workClientChooseForm.init()
      },
      openWorkClient2 () {
        this.$refs.workClientChooseRadio.init()
      },
      getWorkClientChoose (list) {
        // console.log('list', list)
        if (this.commonJS.isEmpty(this.inputForm.cwWorkClientContactDTOList)) {
          this.inputForm.cwWorkClientContactDTOList = []
        }
        let _this = this
        let _list = list
        const waitForEach = function () {
          return new Promise(function (resolve, reject) {
            _list.forEach((item) => {
              _this.inputForm.cwWorkClientContactDTOList.forEach(client => {
                if (item.no === client.no) {
                  _this.$message.error('已存在客户 “' + client.name + '”，请重新选择')
                  throw new Error('已存在客户 “' + client.name + '”，请重新选择')
                }
              })
            })
            resolve()
          })
        }
        waitForEach().then(() => {
          list.forEach(item => {
            this.$refs.contactTable.insertAt(item)
            this.inputForm.cwWorkClientContactDTOList.push(item)
            this.tableKeyClient = Math.random()
          })
        })
      },
      getWorkClientChoose2 (list) {
        if (this.commonJS.isEmpty(this.inputForm.cwWorkClientContactDTOList)) {
          this.inputForm.cwWorkClientContactDTOList = []
        }
        // console.log('list', list)
        let _this = this
        // eslint-disable-next-line no-unused-vars
        let _list = list
        let _num = 0
        const waitForEach = function () {
          return new Promise(function (resolve, reject) {
            if (_this.commonJS.isEmpty(_this.inputForm.cwWorkClientContactDTOList)) {
              resolve()
            } else {
              _this.inputForm.cwWorkClientContactDTOList.forEach((client, index) => {
                if (_this.inputForm.customerNo === client.no) {
                  _this.$refs.contactTable.remove(client)
                  _this.inputForm.cwWorkClientContactDTOList.splice(index, 1)
                }
              })
              setTimeout(() => {
                resolve()
              }, 400)
            }
          })
        }
        waitForEach().then(() => {
          this.inputForm.customerNo = list.no
          this.inputForm.uscCode = list.uscCode
          this.inputForm.address = list.address
          this.inputForm.customerId = list.id
          this.inputForm.clientContacts = list.name
          this.inputForm.clientContactsPhone = list.mobile
          const wait = function () {
            return new Promise(function (resolve, reject) {
              _this.inputForm.cwWorkClientContactDTOList.forEach(client => {
                if (_list.no === client.no) {
                  _num = 1
                }
              })
              setTimeout(() => {
                resolve()
              }, 100)
            })
          }
          wait().then(() => {
            if (_num === 0) {
              this.inputForm.cwWorkClientContactDTOList.push({no: list.no, name: list.name})
              this.$refs.contactTable.insertAt({no: list.no, name: list.name})
              this.tableKeyClient = Math.random()
            }
          })
        })
      },
      // 表单提交
      // 暂存
      doSubmit () {
        this.loading = true
        if (this.commonJS.isEmpty(this.inputForm.cwWorkClientContactDTOList)) {
          this.loading = false
          this.$message.error('“参与签约方”中至少有一条数据')
          throw new Error('“参与签约方”中至少有一条数据')
        }
        if (this.$refs.uploadComponent.checkProgress()) {
          this.loading = false
          throw new Error()
        } else {
          this.$refs['inputForm'].validate((valid) => {
            if (valid) {
              this.loading = true
              this.inputForm.status = '5'
              this.inputForm.contractProperList = this.$refs.uploadComponent.getDataList()
              if (this.commonJS.isEmpty(this.inputForm.contractProperList)) {
                // 附件至少上传一条
                this.$message.error('至少上传一个附件信息')
                this.loading = false
                throw new Error('至少上传一个附件信息')
              }
              this.inputForm.fees = this.inputForm.contractFees.join(',')
              this.contractInfoService.save(this.inputForm).then(({data}) => {
                this.$refs.inputForm.resetFields()
                this.loading = false
                this.close()
                this.$emit('refreshDataList')
              }).catch(() => {
                this.$refs.inputForm.resetFields()
                this.loading = false
              })
            } else {
              this.loading = false
            }
          })
        }
      },
      // 送审
      startForm (callback) {
        this.loading = true
        if (this.commonJS.isNotEmpty(this.inputForm.id)) {
          this.contractInfoService.findById(this.inputForm.id).then(({data}) => {
            if (data.status !== '0' && data.status !== '1' && data.status !== '3') { // // 审核状态不是“未发起”或“暂存”或“撤回”，就弹出提示
              this.loading = false
              this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
              throw new Error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
            } else {
              this.startFormTrue(callback)
            }
          })
        } else {
          this.startFormTrue(callback)
        }
      },
      startFormTrue (callback) {
        this.loading = true
        if (this.commonJS.isEmpty(this.inputForm.cwWorkClientContactDTOList)) {
          this.loading = false
          this.$message.error('“参与签约方”中至少有一条数据')
          throw new Error('“参与签约方”中至少有一条数据')
        } else if (/* this.$refs.archiveFile.checkProgress() || */ this.$refs.uploadComponent.checkProgress()) {
          this.loading = false
          throw new Error()
        } else {
          this.$refs['inputForm'].validate(async (valid) => {
            if (valid) {
              this.loading = true
              this.inputForm.status = '2'
              this.inputForm.contractProperList = this.$refs.uploadComponent.getDataList()
              this.inputForm.fees = this.inputForm.contractFees.join(',')
              await this.contractInfoService.save(this.inputForm).then(({data}) => {
                // this.inputForm.title = `${this.$store.state.user.name} 发起了 ${data.no} [财务-发票申请]`
                this.inputForm.id = data.businessId
                callback(data.businessTable, data.businessId, this.inputForm)
                this.$refs.inputForm.resetFields()
                this.loading = false
              }).catch(() => {
                this.$refs.inputForm.resetFields()
                this.loading = false
              })
            } else {
              this.loading = false
            }
          })
        }
      },
      // 通过
      agreeForm (callback) {
        this.loading = true
        if (/* this.$refs.archiveFile.checkProgress() || */ this.$refs.uploadComponent.checkProgress()) {
          this.loading = false
          throw new Error()
        } else {
          this.$refs['inputForm'].validate(async (valid) => {
            if (valid) {
              this.loading = true
              this.inputForm.status = '5'
              this.inputForm.contractProperList = this.$refs.uploadComponent.getDataList()
              this.inputForm.fees = this.inputForm.contractFees.join(',')
              await this.contractInfoService.save(this.inputForm).then(({data}) => {
                callback(data.businessTable, data.businessId, this.inputForm)
                this.$refs.inputForm.resetFields()
                this.loading = false
              }).catch(() => {
                this.$refs.inputForm.resetFields()
                this.loading = false
              })
            } else {
              this.loading = false
            }
          })
        }
      },
      changeContractFee () {
        let fee = ''
        let fees = this.inputForm.contractFees
        if (fees.length > 0) {
          fees.forEach(i => {
            if (i === '1') {
              i = '发改价格[2009]2914号'
              fee = fee + ';' + i
            }
            if (i === '2') {
              i = '其他'
              fee = fee + ';' + i
            }
            this.inputForm.contractFee = fee.substring(1, fee.length)
          })
        } else {
          this.inputForm.contractFee = ''
        }
      },
      close () {
        this.$refs.inputForm.resetFields()
        this.inputForm.clientName = ''
        this.inputForm.cwWorkClientContactDTOList = []
        this.visible = false
        this.showVi = true
        this.$refs.uploadComponent.clearUpload()
      },
      tabHandleClick (event) {
        // console.log(event)
      },
      httpRequest (file) {
        httpRequest(file, fileName(file), 'workContract')
      },
      handleRemove () {
        this.fileList = handleRemove()
      },
      changes (file, fileList) {
        this.dataListNew = []
        this.dataList.forEach((item) => {
          this.dataListNew.push(item)
        })
        fileList.forEach((item) => {
          item.createDate = moment(new Date()).format('YYYY-MM-DD HH:mm:ss')
          item.createBy = this.$store.state.user.name
          this.dataListNew.push(item)
        })
        const isLt2M = file.size / 1024 / 1024 < 300
        if (isLt2M === false) {
          this.$message.error('文件大小不能超过 ' + 300 + 'M !')
          this.fileList = []
          this.filesArra2 = []
        }
      },
      async showFile (row) {
        await openWindowOnUrl(row)
      },
      // 排序
      sortChangeHandle (column) {
        this.orders = []
        if (column.order != null) {
          this.orders.push({column: this.$utils.toLine(column.prop), asc: column.order === 'ascending'})
        }
        this.refreshList()
      },
      deleteMsgById (row, index) {
        this.dataListNew.splice(index, 1)
        if (row.id !== null && row.id !== '' && row.id !== undefined) {
          this.ossService.deleteMsgById(row.id)
        }
      },
      twoDecimalPlaces (num) {
        let str = num.toString()
        var len1 = str.substr(0, 1)
        var len2 = str.substr(1, 1)
        // eslint-disable-next-line eqeqeq
        if (str.length > 1 && len1 == 0 && len2 != '.') {
          str = str.substr(1, 1)
        }
        // eslint-disable-next-line eqeqeq
        if (len1 == '.') {
          str = ''
        }
        // eslint-disable-next-line eqeqeq
        if (str.indexOf('.') != -1) {
          var str_ = str.substr(str.indexOf('.') + 1)
          // eslint-disable-next-line eqeqeq
          if (str_.indexOf('.') != -1) {
            str = str.substr(0, str.indexOf('.') + str_.indexOf('.') + 1)
          }
          if (str_.length > 2) {
            this.$message.warning(`金额小数点后只能输入两位，请正确输入！`)
            return (str = '')
          }
        }
        // eslint-disable-next-line no-useless-escape
        str = str.replace(/[^\d^\.]+/g, '') // 保留数字和小数点
        return str
      },
      positiveInteger (num) {
        let str = num.toString()
        var len1 = str.substr(0, 1)
        var len2 = str.substr(1, 1)
        // eslint-disable-next-line eqeqeq
        if (str.length > 1 && len1 == 0 && len2 != '.') {
          str = str.substr(1, 1)
        }
        // eslint-disable-next-line eqeqeq
        if (len1 == '.') {
          str = ''
        }
        // eslint-disable-next-line no-useless-escape
        str = str.replace(/[^\d^]+/g, '') // 保留数字
        return str
      },
      tableRowClassName ({row, rowIndex}) {
        row.index = rowIndex
      },
      handleRadioChange (val) {
        if (val) {
          this.radio = val.index
        }
      },
      // 关闭窗口时调用
      closeXTable () {
        this.closePop()
      },
      rowStyle (event) {
        return 'cursor:pointer;'
      },
      closePop () {
        this.visable = false
      },
      // updateStatusById (type) {
      //   if (this.$refs.archiveFile.checkProgress() || this.$refs.uploadComponent.checkProgress()) {
      //     this.loading = false
      //     throw new Error()
      //   } else {
      //     if (type === 'agree') {
      //       this.inputForm.status = '5'
      //       this.contractInfoService.updateStatusById(this.inputForm)
      //     }
      //     // 驳回
      //     if (type === 'reject') {
      //       this.inputForm.status = '4'
      //       this.contractInfoService.updateStatusById(this.inputForm)
      //     }
      //     if (type === 'reback') {
      //       this.inputForm.status = '3'
      //       this.contractInfoService.updateStatusById(this.inputForm)
      //     }
      //     // 流程终止，调整为暂存状态
      //     if (type === 'hold') {
      //       this.inputForm.status = '1'
      //       this.contractInfoService.updateStatusById(this.inputForm)
      //     }
      //   }
      // },
      async updateStatusById (type, callback) {
        this.loading = true
        console.log('进入会计-合同登记 updateStatusById 方法')
        if (await this.$refs.uploadComponent.checkProgress()) {
          this.loading = false
          throw new Error()
        } else {
          if (type === 'reject' || type === 'reback') {
            this.contractInfoService.findById(this.inputForm.id).then(({data}) => {
              if (data.status !== '2') { // status的值不等于“审核中”，就弹出提示
                this.loading = false
                this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
                throw new Error()
              } else {
                // if (type === 'agree') {
                //   // 同意
                //   this.inputForm.status = '5'
                // }
                if (type === 'reject') {
                  // 驳回
                  this.inputForm.status = '4'
                }
                if (type === 'reback') {
                  // 撤回
                  this.inputForm.status = '3'
                }
                if (type === 'reject' || type === 'reback') {
                  let param = {status: this.inputForm.status, id: this.inputForm.id}
                  this.contractInfoService.updateStatusById(param).then(() => {
                    this.loading = false
                    callback()
                  })
                }
              }
            })
          } else if (type === 'hold') {
            this.loading = true
            this.contractInfoService.findById(this.inputForm.id).then(({data}) => {
              if (data.status !== '4') { // status的值不等于“驳回”就弹出提示
                this.loading = false
                this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
                throw new Error()
              } else {
                // 终止
                let param = {status: '1', id: this.inputForm.id}
                this.contractInfoService.updateStatusById(param).then(() => {
                  this.loading = false
                  callback()
                })
              }
            })
          }
        }
      },
      reapplyForm (callback) {
        this.loading = true
        this.contractInfoService.findById(this.inputForm.id).then(({data}) => {
          if (data.status !== '4') { // 审核状态不是“驳回”，就弹出提示
            this.loading = false
            this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
            throw new Error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
          } else {
            this.startFormTrue(callback)
          }
        })
      },
      checkData () {
        let begin = this.inputForm.effectiveDate
        let close = this.inputForm.closingDate
        if (close < begin) {
          this.$message.warning(`合同终止日期要大于合同开始日期`)
          this.inputForm.closingDate = ''
        }
      },
      // 查看客户信息详情
      viewClient (id) {
        this.$refs.workClientForm.init('view', id)
      }
    }
  }
</script>

<style>
  .tid_40 .vxe-body--column .vxe-cell{
    padding: 1px;
    text-align: center;
  }
  .tid_40 .vxe-header--row .col--last{
    text-align: center;
  }
  .tid_45 .vxe-body--column .vxe-cell{
    padding: 1px;
    text-align: center;
  }
  .tid_45 .vxe-header--row .col--last{
    text-align: center;
  }
</style>

<style scoped>
  .avatar{
    height: 100px;
  }
  .el-divider__text {
    font-weight: bold;
    font-size: 16px;
  }
</style>
